#include <math.h>
#include "Dist.h"
#include "AsianOption.h"

// -----------------------------------------------------------------------

double Option (double K, double S0, double r, double T1, double T, 
               double sigma, int dim, double *point)
{
  int i;
  double S, phi;
  double treal, sum, deltat;
  double temp1, temp2;

  treal = ((double) dim);
  
  deltat = (T - T1) / treal;
  
  phi = Normal (0.0, 1.0, point[0]);

  S = exp((r-0.5*sigma*sigma)*(T1+deltat) + (sigma*phi*sqrt(T1+deltat)));

  sum = S;

  temp1 = (r - 0.5 * sigma * sigma) * deltat;
  temp2 = sigma * sqrt(deltat);

  for(i = 1; i < dim; i++)
    {
      phi = Normal (0.0, 1.0, point[i]);
      S = S * exp (temp1 + temp2 * phi);
      sum = sum + S;
    }

  sum = S0 * (sum / treal) - K;

  if (sum > 0.0)
    return (exp(-r * T) * sum);
  else
    return (0.0);
}

// ------------------------------------------------------------------------
